ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
(Generate patch)

Comparing ray/src/util/genBSDF.pl (file contents):
Revision 2.10 by greg, Tue Feb 22 22:51:23 2011 UTC vs.
Revision 2.14 by greg, Sat Apr 16 01:13:22 2011 UTC

# Line 6 | Line 6
6   #       G. Ward
7   #
8   use strict;
9 + use File::Temp qw/ :mktemp  /;
10   sub userror {
11 <        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom] [input ..]\n";
11 >        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom] [input ..]\n";
12          exit 1;
13   }
14 < my $td = `mktemp -d /tmp/genBSDF.XXXXXX`;
14 > my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
15   chomp $td;
16   my $nsamp = 1000;
17   my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
# Line 61 | Line 62 | if ( $mgfin ) {
62          die "Could not load MGF input\n" if ( $? );
63          system "mgf2rad $mgfscn > $radscn";
64   } else {
65 <        system "cat @ARGV | xform -e > $radscn";
65 >        system "xform -e @ARGV > $radscn";
66          die "Could not load Radiance input\n" if ( $? );
67          system "rad2mgf $radscn > $mgfscn" if ( $geout );
68   }
# Line 106 | Line 107 | KprojOmega = PI * if(Kbin-.5,
107   # Compute Klems bin from exiting ray direction (forward or backward)
108   my $kcal = '
109   DEGREE : PI/180;
110 + abs(x) : if(x, x, -x);
111   Acos(x) : 1/DEGREE * if(x-1, 0, if(-1-x, 0, acos(x)));
112   posangle(a) : if(-a, a + 2*PI, a);
113   Atan2(y,x) : 1/DEGREE * posangle(atan2(y,x));
# Line 126 | Line 128 | kbin2(pol,azi) = select(kfindrow(1, pol),
128                  kaccum(7) + kazn(azi,360/knaz(8)),
129                  kaccum(8) + kazn(azi,360/knaz(9))
130          );
131 < kbin = if(Dz, kbin2(Acos(Dz),Atan2(Dy,Dx)), kbin2(Acos(-Dz),Atan2(-Dy,-Dx)));
131 > kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
132   ';
133   my $ndiv = 145;
134   my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
# Line 146 | Line 148 | my $rccmd = "rcalc -e '$tcal' " .
148          q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega'};
149   if ( $doforw ) {
150   $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
151 <        "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
152 <        "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
151 >        "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
152 >        "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
153          "-e 'zp:$dim[4]' " .
154 <        q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
154 >        q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
155          q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
156          "| $rtcmd";
157   system "$cmd" || die "Failure running: $cmd\n";
# Line 164 | Line 166 | $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
166          "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
167          "-e 'zp:$dim[5]' " .
168          q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
169 <        q{-e '$1=xp+Dx;$2=yp+Dy;$3=zp+Dz;$4=-Dx;$5=-Dy;$6=-Dz' } .
169 >        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
170          "| $rtcmd";
171   system "$cmd" || die "Failure running: $cmd\n";
172   @tbarr = `$rccmd $td/$bmodnm.flt`;
# Line 191 | Line 193 | print "\t\t\t<DeviceType>Integral</DeviceType>\n";
193   if ( $geout ) {
194          print "\t\t\t<Geometry format=\"MGF\" unit=\"Meter\">\n";
195          printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
196 <        system "cat $mgfscn";
196 >        open(MGFSCN, "< $mgfscn");
197 >        while (<MGFSCN>) { print $_; }
198 >        close MGFSCN;
199          print "xf\n";
200          print "\t\t\t</Geometry>\n";
201   }

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines